## hypre 2.22.1

=== src/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

cmake_minimum_required(VERSION 3.13...3.16)

if (${CMAKE_VERSION} VERSION_LESS 3.16)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else ()
  cmake_policy(VERSION 3.16)
endif ()

# The version number.
set(HYPRE_VERSION 2.22.1)
set(HYPRE_NUMBER  22201)
set(HYPRE_DATE    2021/08/20)
set(HYPRE_TIME    00:00:00)
set(HYPRE_BUGS    https://github.com/hypre-space/hypre/issues)
set(HYPRE_SRCDIR  "${PROJECT_SOURCE_DIR}")

set(PROJECT_NAME HYPRE)
project(${PROJECT_NAME}
  VERSION ${HYPRE_VERSION}
  LANGUAGES C)

if (${HYPRE_SOURCE_DIR} STREQUAL ${HYPRE_BINARY_DIR})
  message(FATAL_ERROR "In-place build not allowed! Please use a separate build directory. See the Users Manual or INSTALL file for details.")
endif ()

# Set cmake module path
set(CMAKE_MODULE_PATH "${HYPRE_SOURCE_DIR}/config/cmake" "${CMAKE_MODULE_PATH}")
include(HYPRE_CMakeUtilities)

# Set default installation directory, but provide a means for users to change
set(HYPRE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/hypre" CACHE PATH
    "Installation directory for HYPRE")
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${HYPRE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
endif ()

# Set default compile optimization flag
set(HYPRE_BUILD_TYPE "Release" CACHE STRING
    "Optimization flags: set to Debug, Release, RelWithDebInfo, or MinSizeRel")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "${HYPRE_BUILD_TYPE}" CACHE INTERNAL "" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

# Configuration options
option(HYPRE_ENABLE_SHARED           "Build a shared library" OFF)
option(HYPRE_ENABLE_BIGINT           "Use long long int for HYPRE_Int" OFF)
option(HYPRE_ENABLE_MIXEDINT         "Use long long int for HYPRE_BigInt, int for HYPRE_INT" OFF)
option(HYPRE_ENABLE_SINGLE           "Use float for HYPRE_Real" OFF)
option(HYPRE_ENABLE_LONG_DOUBLE      "Use long double for HYPRE_Real" OFF)
option(HYPRE_ENABLE_COMPLEX          "Use complex values" OFF)
option(HYPRE_ENABLE_HYPRE_BLAS       "Use internal BLAS library" ON)
option(HYPRE_ENABLE_HYPRE_LAPACK     "Use internal LAPACK library" ON)
option(HYPRE_ENABLE_PERSISTENT_COMM  "Use persistent communication" OFF)
option(HYPRE_ENABLE_FEI              "Use FEI" OFF) # TODO: Add this cmake feature
option(HYPRE_WITH_MPI                "Compile with MPI" ON)
option(HYPRE_WITH_OPENMP             "Use OpenMP" OFF)
option(HYPRE_ENABLE_HOPSCOTCH        "Use hopscotch hashing with OpenMP" OFF)
option(HYPRE_WITH_DSUPERLU           "Use TPL SuperLU_Dist" OFF)
option(HYPRE_WITH_CALIPER            "Use Caliper" OFF)  # TODO: Finish this cmake feature
option(HYPRE_PRINT_ERRORS            "Print HYPRE errors" OFF)
option(HYPRE_TIMING                  "Use HYPRE timing routines" OFF)
option(HYPRE_BUILD_EXAMPLES          "Build examples" OFF)
option(HYPRE_BUILD_TESTS             "Build tests" OFF)
option(HYPRE_USING_HOST_MEMORY       "Use host memory" ON)
set(HYPRE_WITH_EXTRA_CFLAGS       "" CACHE STRING "Define extra C compile flags")
set(HYPRE_WITH_EXTRA_CXXFLAGS     "" CACHE STRING "Define extra CXX compile flags")
# CUDA options
option(HYPRE_WITH_CUDA               "Use CUDA. Require cuda-8.0 or higher" OFF)
option(HYPRE_ENABLE_UNIFIED_MEMORY   "Use unified memory for allocating the memory" OFF)
option(HYPRE_ENABLE_CUDA_STREAMS     "Use CUDA streams" ON)
option(HYPRE_ENABLE_CUSPARSE         "Use cuSPARSE" ON)
option(HYPRE_ENABLE_DEVICE_POOL      "Use device memory pool" OFF)
option(HYPRE_ENABLE_CUBLAS           "Use cuBLAS" OFF)
option(HYPRE_ENABLE_CURAND           "Use cuRAND" ON)
option(HYPRE_ENABLE_GPU_PROFILING    "Use NVTX on CUDA" OFF)
set(HYPRE_CUDA_SM "70" CACHE STRING  "Target CUDA architecture.")

option(TPL_DSUPERLU_LIBRARIES        "List of absolute paths to SuperLU_Dist link libraries [].")
option(TPL_DSUPERLU_INCLUDE_DIRS     "List of absolute paths to SuperLU_Dist include directories [].")
option(TPL_BLAS_LIBRARIES            "Optional list of absolute paths to BLAS libraries, otherwise use FindBLAS to locate [].")
option(TPL_LAPACK_LIBRARIES          "Optional list of absolute paths to LAPACK libraries, otherwise use FindLAPACK to locate [].")

# Set config name values
if (HYPRE_ENABLE_SHARED)
  set(HYPRE_SHARED ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_BIGINT)
  set(HYPRE_BIGINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_MIXEDINT)
  set(HYPRE_MIXEDINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_SINGLE)
  set(HYPRE_SINGLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_LONG_DOUBLE)
  set(HYPRE_LONG_DOUBLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_COMPLEX)
  set(HYPRE_COMPLEX ON CACHE BOOL "" FORCE)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(HYPRE_DEBUG ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_BLAS)
  set(HYPRE_USING_HYPRE_BLAS ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_LAPACK)
  set(HYPRE_USING_HYPRE_LAPACK ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_PERSISTENT_COMM)
  set(HYPRE_USING_PERSISTENT_COMM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_MPI)
  set(HYPRE_HAVE_MPI ON CACHE BOOL "" FORCE)
  set(HYPRE_SEQUENTIAL OFF CACHE BOOL "" FORCE)
else ()
  set(HYPRE_SEQUENTIAL ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_OPENMP)
  set(HYPRE_USING_OPENMP ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HOPSCOTCH)
  set(HYPRE_HOPSCOTCH ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_DSUPERLU)
  set(HYPRE_USING_DSUPERLU ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_BLAS OFF CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_LAPACK OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_FEI)
  set(HYPRE_USING_FEI ON CACHE BOOL "" FORCE)
  message(WARNING "CMake support for FEI is not complete!")
endif ()

if (HYPRE_WITH_CALIPER)
  set(HYPRE_USING_CALIPER ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SHARED OR HYPRE_BIGINT OR HYPRE_SINGLE OR HYPRE_LONG_DOUBLE)
  # FEI doesn't currently compile with shared
  set(HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SEQUENTIAL)
  set(HYPRE_BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)
endif ()

# CUDA
if (HYPRE_WITH_CUDA)
  enable_language(CXX)
  message(STATUS "Enabled support for CXX.")

  # Enforce C++11
  if (NOT CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 11)
    set(CMAKE_CXX_STANDARD 11)
  endif ()
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  message(STATUS "Using CXX standard: c++${CMAKE_CXX_STANDARD}")

  # Use ${CMAKE_CXX_COMPILER} as the cuda host compiler.
  if (NOT CMAKE_CUDA_HOST_COMPILER)
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
  endif ()

  # Add any extra CXX compiler flags HYPRE_WITH_EXTRA_CXXFLAGS
  if (NOT HYPRE_WITH_EXTRA_CXXFLAGS STREQUAL "")
    string(REPLACE " " ";" HYPRE_WITH_EXTRA_CXXFLAGS "${HYPRE_WITH_EXTRA_CXXFLAGS}")
    add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${HYPRE_WITH_EXTRA_CXXFLAGS}>")
  endif ()

  # Check if CUDA is available, then enable it
  include(CheckLanguage)
  check_language(CUDA)
  if (CMAKE_CUDA_COMPILER)

    enable_language(CUDA)
    message(STATUS "Enabled support for CUDA.")

    if (NOT CMAKE_CUDA_STANDARD OR CMAKE_CUDA_STANDARD EQUAL 98)
      set(CMAKE_CUDA_STANDARD 11)
    endif ()

    set(CMAKE_CUDA_STANDARD_REQUIRED ON CACHE BOOL "" FORCE)

    set(HYPRE_USING_CUDA ON CACHE BOOL "" FORCE)
    set(HYPRE_USING_GPU ON CACHE BOOL "" FORCE)

    if (HYPRE_ENABLE_UNIFIED_MEMORY)
      set(HYPRE_USING_UNIFIED_MEMORY ON CACHE BOOL "" FORCE)
    else ()
      set(HYPRE_USING_DEVICE_MEMORY ON CACHE BOOL "" FORCE)
    endif ()

    # Check if examples are enabled, but not unified memory
    if (HYPRE_BUILD_EXAMPLES AND NOT HYPRE_ENABLE_UNIFIED_MEMORY)
      message(WARNING "Running the examples on GPUs requires Unified Memory!
        Examples will not be built!")
      set(HYPRE_BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)
    endif ()

    if (CMAKE_VERSION VERSION_LESS 3.18.0)
      add_compile_options("$<$<COMPILE_LANGUAGE:CUDA>:-arch=sm_${HYPRE_CUDA_SM}>")
    else ()
      set(CMAKE_CUDA_ARCHITECTURES "${HYPRE_CUDA_SM}")
    endif ()
    message(STATUS "Using CUDA architecture: ${HYPRE_CUDA_SM}")

    add_compile_options("$<$<COMPILE_LANGUAGE:CUDA>:-expt-extended-lambda>")

    set(HYPRE_USING_HOST_MEMORY OFF CACHE BOOL "" FORCE)

    if (HYPRE_ENABLE_CUDA_STREAMS)
      set(HYPRE_USING_CUDA_STREAMS ON CACHE BOOL "" FORCE)
    endif (HYPRE_ENABLE_CUDA_STREAMS)

    if (HYPRE_ENABLE_DEVICE_POOL)
      set(HYPRE_USING_DEVICE_POOL ON CACHE BOOL "" FORCE)
    endif (HYPRE_ENABLE_DEVICE_POOL)

    # TODO Eventually should require cmake>=3.17
    # and use cmake's FindCUDAToolkit. Now collect
    # CUDA optional libraries.
    include(HYPRE_SetupCUDAToolkit)
  else ()
    message(WARNING "No CUDA support!")
    set(HYPRE_USING_HOST_MEMORY ON CACHE BOOL "" FORCE)
  endif (CMAKE_CUDA_COMPILER)
endif (HYPRE_WITH_CUDA)

# Add any extra C compiler flags HYPRE_WITH_EXTRA_CFLAGS
if (NOT HYPRE_WITH_EXTRA_CFLAGS STREQUAL "")
  string(REPLACE " " ";" HYPRE_WITH_EXTRA_CFLAGS "${HYPRE_WITH_EXTRA_CFLAGS}")
  add_compile_options("$<$<COMPILE_LANGUAGE:C>:${HYPRE_WITH_EXTRA_CFLAGS}>")
endif ()

# Set library build type (must appear before add_library calls)
if (HYPRE_SHARED)
  set(BUILD_SHARED_LIBS ON CACHE INTERNAL "" FORCE)
else ()
  set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "" FORCE)
endif ()

# Create the HYPRE library object
add_library(${PROJECT_NAME})

# Headers and sources
set(HYPRE_HEADERS "")

# Headers and sources: .
set(HYPRE_MAIN_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/HYPRE_config.h
  HYPREf.h
  HYPRE.h
  )

set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HYPRE_MAIN_HEADERS})

# Headers and sources: blas
if (HYPRE_USING_HYPRE_BLAS)
  add_subdirectory(blas)
else ()
  # Use TPL_BLAS_LIBRARIES if set.
  if (TPL_BLAS_LIBRARIES)
    message(STATUS "Using TPL_BLAS_LIBRARIES='${TPL_BLAS_LIBRARIES}'")
    target_link_libraries(${PROJECT_NAME} PUBLIC "${TPL_BLAS_LIBRARIES}")
  else ()
    # Find system blas
    find_package(BLAS REQUIRED)
    target_link_libraries(${PROJECT_NAME} PUBLIC "${BLAS_LIBRARIES}")
  endif ()
  target_compile_definitions(${PROJECT_NAME} PUBLIC "USE_VENDOR_BLAS")
endif ()

# Headers and sources: lapack
if (HYPRE_USING_HYPRE_LAPACK)
  add_subdirectory(lapack)
else ()
  # Use TPL_LAPACK_LIBRARIES if set.
  if (TPL_LAPACK_LIBRARIES)
    message(STATUS "Using TPL_LAPACK_LIBRARIES='${TPL_LAPACK_LIBRARIES}'")
    target_link_libraries(${PROJECT_NAME} PUBLIC "${TPL_LAPACK_LIBRARIES}")
  else ()
    # Find system lapack
    find_package(LAPACK REQUIRED)
    target_link_libraries(${PROJECT_NAME} PUBLIC "${LAPACK_LIBRARIES}")
  endif ()
endif ()

# Find DSUPERLU, if requested
if (HYPRE_USING_DSUPERLU)
  if (NOT TPL_DSUPERLU_LIBRARIES)
    message(FATAL_ERROR "TPL_DSUPERLU_LIBRARIES option should be set for SuperLU_Dist support.")
  endif ()

  if (NOT TPL_DSUPERLU_INCLUDE_DIRS)
    message(FATAL_ERROR "TPL_DSUPERLU_INCLUDE_DIRS option be set for SuperLU_Dist support.")
  endif ()

  foreach (dir ${TPL_DSUPERLU_INCLUDE_DIRS})
    if (NOT EXISTS ${dir})
      message(FATAL_ERROR "SuperLU_Dist include directory not found: ${dir}")
    endif ()
    set(CMAKE_C_FLAGS "-I${dir} ${CMAKE_C_FLAGS}")
  endforeach ()
  message(STATUS "Enabled support for using DSUPERLU.")
  set(DSUPERLU_FOUND TRUE)
  target_link_libraries(${PROJECT_NAME} PUBLIC ${TPL_DSUPERLU_LIBRARIES} stdc++)
  target_include_directories(${PROJECT_NAME} PUBLIC ${TPL_DSUPERLU_INCLUDE_DIRS})
endif (HYPRE_USING_DSUPERLU)

if (DSUPERLU_FOUND)
  set(HYPRE_USING_DSUPERLU TRUE)
endif ()

if (HYPRE_USING_CUDA)
  target_link_libraries(${PROJECT_NAME} PUBLIC "${EXPORT_INTERFACE_CUDA_LIBS}")
  if (HYPRE_HAVE_MPI)

=== src/FEI_mv/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)


project(HYPRE_FEI C CXX)

include_directories(fei-hypre)

# option(HYPRE_USING_SUPERLU "Use internal SuperLU routines" ON)
# option(HYPRE_USING_MLI     "Use MLI" ON)
# 
# if(HYPRE_USING_SUPERLU)
#   include_directories(SuperLU/SRC)
#   add_definitions(-DHAVE_SUPERLU)
#   add_subdirectory(SuperLU)
#   set(FEI_LIBS ${FEI_LIBS} $<TARGET_OBJECTS:HYPRE_superlu>)
# endif()
# 
# if(HYPRE_USING_MLI)
#   include_directories(femli)
#   add_definitions(-DHAVE_MLI)
#   if(HYPRE_USING_SUPERLU)
#     add_definitions(-DMLI_SUPERLU)
#   endif()
#   add_subdirectory(femli)
#   set(FEI_LIBS ${FEI_LIBS} $<TARGET_OBJECTS:HYPRE_mli>)
# endif()

add_subdirectory(fei-hypre)
set(FEI_LIBS ${FEI_LIBS} $<TARGET_OBJECTS:HYPRE_fei>)

set(FEI_LIBS ${FEI_LIBS} PARENT_SCOPE)

=== src/IJ_mv/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  aux_parcsr_matrix.h
  aux_par_vector.h
  HYPRE_IJ_mv.h
  _hypre_IJ_mv.h
  IJ_matrix.h
  IJ_vector.h
)

set(SRCS
  aux_parcsr_matrix.c
  aux_par_vector.c
  F90_HYPRE_IJMatrix.c
  F90_HYPRE_IJVector.c
  F90_IJMatrix.c
  HYPRE_IJMatrix.c
  HYPRE_IJVector.c
  IJ_assumed_part.c
  IJMatrix.c
  IJMatrix_parcsr.c
  IJVector.c
  IJVector_parcsr.c
  IJMatrix_parcsr_device.c
  IJVector_parcsr_device.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA)
  set(CUDA_SRCS
    IJMatrix_parcsr_device.c
    IJVector_parcsr_device.c
  )
  convert_filenames_to_full_paths(CUDA_SRCS)
  set(HYPRE_CUDA_SOURCES ${HYPRE_CUDA_SOURCES} ${CUDA_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/IJ_mv/Makefile ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../parcsr_ls\
 ${CINCLUDES}

HEADERS =\
 aux_parcsr_matrix.h\
 aux_par_vector.h\
 HYPRE_IJ_mv.h\
 _hypre_IJ_mv.h\
 IJ_matrix.h\
 IJ_vector.h

EXTRA_FILES =\
 IJMatrix_isis.c\
 IJMatrix_petsc.c

FILES =\
 aux_parcsr_matrix.c\
 aux_par_vector.c\
 F90_HYPRE_IJMatrix.c\
 F90_HYPRE_IJVector.c\
 F90_IJMatrix.c\
 HYPRE_IJMatrix.c\
 HYPRE_IJVector.c\
 IJ_assumed_part.c\
 IJMatrix.c\
 IJMatrix_parcsr.c\
 IJVector.c\
 IJVector_parcsr.c

CUFILES =\
 IJMatrix_parcsr_device.c\
 IJVector_parcsr_device.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_IJ_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_IJ_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_IJ_mv.so libHYPRE_IJ_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/blas/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  _hypre_blas.h
  f2c.h
  hypre_blas.h
)

set(SRCS
  dasum.c
  daxpy.c
  dcopy.c
  ddot.c
  dgemm.c
  dgemv.c
  dger.c
  dnrm2.c
  drot.c
  dscal.c
  dswap.c
  dsymm.c
  dsymv.c
  dsyr2.c
  dsyr2k.c
  dsyrk.c
  dtrmm.c
  dtrmv.c
  dtrsm.c
  dtrsv.c
  f2c.c
  idamax.c
  lsame.c
  xerbla.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/distributed_ls/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS "")

add_subdirectory(Euclid)
add_subdirectory(ParaSails)
add_subdirectory(pilut)

set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/distributed_matrix/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  distributed_matrix.h
  HYPRE_distributed_matrix_mv.h
  HYPRE_distributed_matrix_protos.h
  HYPRE_distributed_matrix_types.h
)

set(SRCS
  distributed_matrix.c
  distributed_matrix_ISIS.c
  distributed_matrix_parcsr.c
  distributed_matrix_PETSc.c
  HYPRE_distributed_matrix.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/distributed_matrix/Makefile ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../seq_mv\
 ${CINCLUDES}

EXTRA_HEADERS = internal_protos.h

HEADERS =\
 distributed_matrix.h\
 HYPRE_distributed_matrix_mv.h\
 HYPRE_distributed_matrix_protos.h\
 HYPRE_distributed_matrix_types.h

FILES =\
 distributed_matrix.c\
 HYPRE_distributed_matrix.c\
 distributed_matrix_ISIS.c\
 distributed_matrix_PETSc.c\
 distributed_matrix_parcsr.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_DistributedMatrix-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_DistributedMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/distributed_matrix.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_DistributedMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/distributed_matrix.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_DistributedMatrix.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_DistributedMatrix.so libHYPRE_DistributedMatrix.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/docs/Makefile ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

.SUFFIXES:
.SUFFIXES: .c .dxx .html .tex

##################################################################
# Targets
##################################################################

all: usr

install: all
	@ \
	test ! -d ${HYPRE_INSTALL_DIR}/docs && \
	    mkdir -m 755 -p ${HYPRE_INSTALL_DIR}/docs; \
	for dir in HYPRE_usr_manual HYPRE_ref_manual; do \
	  if test -d $$dir; then \
	    test ! -d ${HYPRE_INSTALL_DIR}/docs/$$dir && \
		mkdir -m 755 -p ${HYPRE_INSTALL_DIR}/docs/$$dir; \
	    for file in $$dir/*; do \
	      cp -fp $$file ${HYPRE_INSTALL_DIR}/docs/$$file; \
	    done; \
	  fi; \
	done; \
	for file in HYPRE_usr_manual.pdf HYPRE_ref_manual.pdf; do \
	  test -f $$file && cp -fp $$file ${HYPRE_INSTALL_DIR}/docs/$$file; \
	done

clean:
	@cd usr-manual; make clean
	@cd ref-manual; make clean
	@/bin/rm -fr usr-manual-html ref-manual-html
	@/bin/rm -fr usr-manual.pdf  ref-manual.pdf

distclean: clean

##################################################################
# Rules
##################################################################

usr: ref
	@cd usr-manual; make html; make latexpdf
	@mv usr-manual/_build/html usr-manual-html
	@mv usr-manual/_build/latex/hypre.pdf usr-manual.pdf

ref:
	@cd ref-manual; make
	@mv ref-manual/html ref-manual-html
	@mv ref-manual/latex/refman.pdf ref-manual.pdf

##########

vref_manual.tex: vref_manual.dxx
	doc++ -t -o vref_manual.tex vref_manual.dxx
	mv vref_manual.tex vref_manual.tmp
	sed 's/HYPRE\\_Int\([^a-zA-Z_0-9]\)/int\1/g' vref_manual.tmp > vref_manual.tex

vref_manual.dxx: ref_manual.dxx
	@ \
	sed -e '/HYPRECopyright/r copyright.txt' -e 's/HYPRECopyright//g' -e 's/HYPREVersion/$(HYPRE_RELEASE_VERSION)/g' ref_manual.dxx > vref_manual.dxx

##########

version.tex:
	@ \
	echo "\def\HYPREVersion{$(HYPRE_RELEASE_VERSION)}" > version.tex; \
	echo "\def\HYPREVersionDate{$(HYPRE_RELEASE_DATE)}" >> version.tex

=== src/examples/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(EXAMPLE_SRCS
  ex1.c
  ex2.c
  ex3.c
  ex4.c
  ex5.c
  ex6.c
  ex7.c
  ex8.c
  ex9.c
  ex11.c
  ex12.c
  ex13.c
  ex14.c
  ex15.c
  ex16.c
  ex17.c
  ex18.c
)

if (HYPRE_BIGINT)
  list(APPEND EXAMPLE_SRCS
    ex5big.c
    ex15big.c
  )
endif()

if (HYPRE_COMPLEX)
  list(APPEND EXAMPLE_SRCS
    ex18comp.c
  )
endif()

add_hypre_executables(EXAMPLE_SRCS)

=== src/examples/Makefile ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

########################################################################
# Compiler and external dependences
########################################################################
CC        = mpicc
F77       = mpif77
CXX       = mpicxx
F90       = mpifort
HYPRE_DIR = ../hypre

########################################################################
# Compiling and linking options
########################################################################
COPTS     = -g -Wall
CINCLUDES = -I$(HYPRE_DIR)/include
#CDEFS     = -DHYPRE_EXVIS
CDEFS     = 
CFLAGS    = $(COPTS) $(CINCLUDES) $(CDEFS)
FOPTS     = -g
FINCLUDES = $(CINCLUDES)
FFLAGS    = $(FOPTS) $(FINCLUDES)
CXXOPTS   = $(COPTS) -Wno-deprecated
CXXINCLUDES = $(CINCLUDES) -I..
CXXDEFS   = $(CDEFS)
IFLAGS_BXX = 
CXXFLAGS  = $(CXXOPTS) $(CXXINCLUDES) $(CXXDEFS) $(IFLAGS_BXX)
IF90FLAGS = 
F90FLAGS = $(FFLAGS) $(IF90FLAGS)


LINKOPTS  = $(COPTS)
LIBS      = -L$(HYPRE_DIR)/lib -lHYPRE -lm
LFLAGS    = $(LINKOPTS) $(LIBS) -lstdc++
LFLAGS_B =\
 -L${HYPRE_DIR}/lib\
 -lbHYPREClient-C\
 -lbHYPREClient-CX\
 -lbHYPREClient-F\
 -lbHYPRE\
 -lsidl -ldl -lxml2
LFLAGS77 = $(LFLAGS)
LFLAGS90 =

########################################################################
# Rules for compiling the source files
########################################################################
.SUFFIXES: .c .f .cxx .f90

.c.o:
	$(CC) $(CFLAGS) -c $<
.f.o:
	$(F77) $(FFLAGS) -c $<
.cxx.o:
	$(CXX) $(CXXFLAGS) -c $<

########################################################################
# List of all programs to be compiled
########################################################################
ALLPROGS = ex1 ex2 ex3 ex4 ex5 ex5f ex6 ex7 ex8 ex9 ex11 ex12 ex12f \
           ex13 ex14 ex15 ex16
BIGINTPROGS = ex5big ex15big
FORTRANPROGS = ex5f ex12f
MAXDIMPROGS = ex17 ex18
COMPLEXPROGS = ex18comp

all: $(ALLPROGS)

default: all

bigint: $(BIGINTPROGS)

fortran: $(FORTRANPROGS)

maxdim: $(MAXDIMPROGS)

complex: $(COMPLEXPROGS)

########################################################################
# Example 1
########################################################################
ex1: ex1.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 2
########################################################################
ex2: ex2.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 3
########################################################################
ex3: ex3.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 4
########################################################################
ex4: ex4.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 5
########################################################################
ex5: ex5.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 5 with 64-bit integers
########################################################################
ex5big: ex5big.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 5 Fortran 77
########################################################################
ex5f: ex5f.o
	$(F77) -o $@ $^ $(LFLAGS77)

########################################################################
# Example 6
########################################################################
ex6: ex6.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 7
########################################################################
ex7: ex7.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 8
########################################################################
ex8: ex8.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 9
########################################################################
ex9: ex9.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 10
########################################################################
ex10: ex10.o
	$(CXX) -o $@ $^ $(LFLAGS)

########################################################################
# Example 11
########################################################################
ex11: ex11.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 12
########################################################################
ex12: ex12.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 12 Fortran 77
########################################################################
ex12f: ex12f.o
	$(F77) -o $@ $^ $(LFLAGS77)

########################################################################
# Example 13
########################################################################
ex13: ex13.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 14
########################################################################
ex14: ex14.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 15
########################################################################
ex15: ex15.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 15 with 64-bit integers
########################################################################
ex15big: ex15big.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 16
########################################################################
ex16: ex16.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 17
########################################################################
ex17: ex17.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 18
########################################################################
ex18: ex18.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Example 18 (complex)
########################################################################
ex18comp: ex18comp.o
	$(CC) -o $@ $^ $(LFLAGS)

########################################################################
# Clean up
########################################################################
clean:
	rm -f $(ALLPROGS:=.o)
	rm -f $(BIGINTPROGS:=.o)
	rm -f $(FORTRANPROGS:=.o)
	rm -f $(MAXDIMPROGS:=.o)
	rm -f $(COMPLEXPROGS:=.o)
	cd vis; make clean
distclean: clean
	rm -f $(ALLPROGS) $(ALLPROGS:=*~)
	rm -f $(BIGINTPROGS) $(BIGINTPROGS:=*~)
	rm -f $(FORTRANLPROGS) $(FORTRANPROGS:=*~)
	rm -f $(MAXDIMPROGS) $(MAXDIMPROGS:=*~)
	rm -f $(COMPLEXPROGS) $(COMPLEXPROGS:=*~)
	rm -fr README*

=== src/krylov/CMakeLists.txt ===
# Copyright 1998-2019 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_krylov.h
  HYPRE_lobpcg.h
  HYPRE_MatvecFunctions.h
  krylov.h
  lobpcg.h
)

set(SRCS
  bicgstab.c
  cgnr.c
  cogmres.c
  gmres.c
  flexgmres.c
  lgmres.c
  HYPRE_bicgstab.c
  HYPRE_cgnr.c
  HYPRE_gmres.c
  HYPRE_cogmres.c
  HYPRE_lgmres.c
  HYPRE_flexgmres.c
  HYPRE_pcg.c
  pcg.c
  HYPRE_lobpcg.c
  lobpcg.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== debian/changelog ===
hypre (2.22.1-7) unstable; urgency=medium

  * Team upload.
  * debian/tests: skip TEST_superlu on armhf (consistently times out).
    Closes: #1003020.

 -- Drew Parsons <dparsons@debian.org>  Sat, 19 Feb 2022 12:32:26 +0100

hypre (2.22.1-6) unstable; urgency=medium

  * Team upload.
  * debian/tests: depend on libhypre64 only for 64-bit tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 14 Feb 2022 02:39:06 +0100

hypre (2.22.1-5) unstable; urgency=medium

  * Team upload.
  * refresh debian/watch
  * enable 64-bit build on kfreebsd-amd64 (libblas64-dev is available)

 -- Drew Parsons <dparsons@debian.org>  Sat, 12 Feb 2022 21:32:03 +0100

hypre (2.22.1-4) unstable; urgency=medium

  * Team upload.
  * reinstate versioned library packages
    libhypre-2.22.1, libhypre64-2.22.1, libhypre64m-2.22.1
    in line with standard shared library Policy 8.1.
    Version restriction by shlibs file was making petsc3.14
    uninstallable alongside petsc3.15, interfering with deal.ii
    installation. ABI stability is not provided by HYPRE, so a new
    shared library package will be needed for each upstream patch
    release. Closes: #998411.
  * Provides,Conflicts,Replaces unversioned libhypre[64] (2.22.1)
  * drop custom shlibs files
  * provide static .a libraries in libhypre*-dev packages

 -- Drew Parsons <dparsons@debian.org>  Fri, 05 Nov 2021 09:53:43 +0100

hypre (2.22.1-3) unstable; urgency=medium

  * Team upload.
  * restrict hypre64 tests in debian/test to only those arches which
    provide it. Not available on 32-bit arches since blas64 is not
    available there. Closes: #996895.

 -- Drew Parsons <dparsons@debian.org>  Thu, 21 Oct 2021 14:12:54 +0200

hypre (2.22.1-2) unstable; urgency=medium

  * Team upload.
  * upload HYPRE 2.22 to unstable.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Oct 2021 09:31:27 +0200

hypre (2.22.1-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * provide 64-bit only on arches where libblas64-dev, liblapack64-dev
    are available. Closes: #961645.
    - Test for DEB_HOST_ARCH_BITS=64 in debian/rules
      (following the pattern used by lapack)
  * skip TEST_bench in debian/tests (autopkgtest),
    because life is too short
  * clean test dir before building tests for debian/tests
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Sep 2021 08:52:45 +0200

hypre (2.21.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - src/config/boostrap was renamed to update.sh
      Update debian patch configure.patch to mark it as #!/bin/bash
  * provide 64-bit builds
    - --with-bigint provided in packages libhypre64-dev and libhypre64
      (HYPRE_BigInt and HYPRE_Int both 64 bit)
    - --with-mixedint provided in libhypre64m-dev and libhypre64m
      (64-bit HYPRE_BigInt with 32-bit HYPRE_Int)
      But libhypre64m (mixedint) might not be safe. Segfaults have been
      reported in MPI tests. libhypre64m should be considered
      experimental. See https://github.com/hypre-space/hypre/issues/326
    - debian patch library_name_extension.patch adds
      --with-libname-ext configure option and HYPRE_LIBNAME_EXT
      Makefile variable to add extension to library name, to generate
      libHYPRE64.so or libHYPRE64m.so
    - document 64-bit builds in README.Debian. mixedint libhypre64m
      might give better performance than bigint libhypre64 on cloud
      computing infrastructure with memory bandwidth constraints.
  * drop FEI support (libHYPRE_FEI.so).
    FEI is an external library released by Sandia NL (but no longer
    developed) which needs to be available at build time (defining
    fei_defs.h et al.) in order for HYPRE to support it. FEI source is
    available with Trilinos source, but has not been packaged for
    Debian. FEI source was previously provided with HYPRE (in
    src/FEI_mv/fei-base), but was removed in hypre 2.17.0.
  * provide single library libHYPRE.so.
    i.e. don't split out libHYPRE_core.so, since libHYPRE_FEI.so is
    now dropped
    - drop debian patches install.patch and
      shlibs-interlink-libHYPRE.so.patch
  * report test timings
    - skip TEST_bench at build time (takes a long time to complete)
  * update debian patch test.patch to make awk script in runcheck.sh
    validate that data is being read ((getline < ofilename) > 0).
    Otherwise a memory-leaking infinite loop is formed if output files
    do not exist (e.g. test could not be run), since getline returns -1
    if the file is missing.
  * skip selected tests at build time and in debian/tests (autopkgtest)
    - TEST_bench, takes an unacceptably long time to run (more than
      all other tests combined). Skip at build-time, run in autopkgtest.
    - TEST_examples, TEST_fei, executables are not available
    - TEST_timing, the unusual shell arithmetic in efficiency.sh is
      not supported
    - build-tests are NOT run for the libhypre64m (mixedint) build, due
      to segfaults in MPI tests. libhypre64m might not be safe,
      see above (and https://github.com/hypre-space/hypre/issues/326 )

 -- Drew Parsons <dparsons@debian.org>  Thu, 03 Jun 2021 23:23:24 +0200

hypre (2.20.0-1exp2) experimental; urgency=medium

  * Team upload.
  * rebuild against libsuperlu-dist6.4

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Jan 2021 09:14:37 +1100

hypre (2.20.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - has versioned Build-Depends libsuperlu-dist-dev (>= 6.3)
      (precision-dependent structures dLUstruct_t etc)
  * Standards-Version: 4.5.1
  * debhelper compatibility level 13
  * enclose Adam C. Powell, IV's name in quotes in this changelog

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Jan 2021 22:36:43 +1100

=== debian/control ===
Source: hypre
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 4.6.0
Build-Depends:
 autoconf,
 automake,
 debhelper-compat (= 13),
 pkg-config,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libblas64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 liblapack64-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | liblapack64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 libsuperlu-dev, libsuperlu-dist-dev (>= 6.3),
 libltdl-dev,
 libtool,
 mpi-default-dev,
Vcs-Git: https://salsa.debian.org/science-team/hypre.git
Vcs-Browser: https://salsa.debian.org/science-team/hypre
Homepage: http://www.llnl.gov/casc/hypre/

Package: libhypre-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre-2.22.1 (= ${binary:Version}),
 libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre.

Package: libhypre-2.22.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libhypre (= 2.22.1)
Conflicts: libhypre (>= 2.22.1)
Replaces: libhypre (>= 2.22.1)
Description: High Performance Matrix Preconditioners - Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library.

Package: libhypre64-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64-2.22.1 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit integers for both HYPRE_BigInt
 and HYPRE_Int (--with-bigint).

Package: libhypre64-2.22.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libhypre64 (= 2.22.1)
Conflicts: libhypre64 (>= 2.22.1)
Replaces: libhypre64 (>= 2.22.1)
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit integers
 for both HYPRE_BigInt and HYPRE_Int (--with-bigint).

Package: libhypre64m-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64m-2.22.1 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit HYPRE_BigInt and 32-bit HYPRE_Int
 (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326



Package: libhypre64m-2.22.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libhypre64m (= 2.22.1)
Conflicts: libhypre64m (>= 2.22.1)
Replaces: libhypre64m (>= 2.22.1)
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit
 HYPRE_BigInt with 32-bit HYPRE_Int (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

include /usr/share/dpkg/default.mk

DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')

HYPRE_UPSTREAM_VERSION=$(DEB_UPSTREAM_VERSION)
HYPRE_X_Y_VERSION=$(shell echo $(HYPRE_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
HYPRE_Z_VERSION=$(shell echo $(HYPRE_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\2/")
HYPRE_NEXT_VERSION=$(HYPRE_X_Y_VERSION).$(shell echo $$(( $(HYPRE_Z_VERSION) + 1 )) )

export HYPRE_SOVERSION=$(HYPRE_UPSTREAM_VERSION)

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --sourcedirectory=src --with autoreconf

# to avoid lintian warnings
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# 64-bit build is not supported on all arches
ifneq (64,$(DEB_HOST_ARCH_BITS))
export DH_OPTIONS += \
	-Nlibhypre64-dev -Nlibhypre64-${HYPRE_SOVERSION} \
	-Nlibhypre64m-dev -Nlibhypre64m-${HYPRE_SOVERSION}
endif

# extra flags set to be similar to what petsc requires
extra_flags_common += --with-superlu --with-superlu-include=/usr/include/superlu --with-superlu-lib="-lsuperlu" \
  --with-dsuperlu --with-dsuperlu-include=/usr/include/superlu-dist --with-dsuperlu-lib="-lsuperlu_dist" \
  --with-MPI-include=$(shell pkg-config --cflags-only-I mpi | awk '{print $$1}' | sed "s/^-I//") \
  --with-MPI-libs="$(shell pkg-config --libs-only-l mpi | sed 's/-l//g')" \
  --with-MPI-lib-dirs="$(shell pkg-config --libs-only-L mpi | sed 's/-L//g')" \
  --with-MPI-flags="$(shell pkg-config --libs-only-other mpi)" \
  --with-extra-flags="$(shell pkg-config --cflags-only-other mpi)"

# from pets:
# # explicitly tell hypre BLAS/LAPACK mangling since it may not match Fortran mangling
#    if self.blasLapack.mangling == 'underscore':
#      mang = 'one-underscore'
#    elif self.blasLapack.mangling == 'caps':
#      mang = 'caps-no-underscores'
#    else:
#      mang = 'no-underscores'
#    args.append('--with-fmangle-blas='+mang)
#    args.append('--with-fmangle-lapack='+mang)


# Other options from src/configure
  # --enable-debug          Set compiler flags for debugging.
  # --enable-shared         Build shared libraries (default is NO).
  # --enable-bigint         Use long long int for HYPRE_Int (default is NO).
  # --enable-complex        Use complex values (default is NO).
  # --enable-maxdim=MAXDIM  Change max dimension size to MAXDIM (default is 3).
  #                         Currently must be at least 3.
  # --enable-persistent     Uses persistent communication (default is NO).
  # --enable-hopscotch      Uses hopscotch hashing if configured with OpenMP and
  #                         atomic capability available(default is NO).
  # --enable-global-partition
  #                         Use global partitioning (default is NO).
  # --enable-fortran        Require a working Fortran compiler (default is YES).

export OMPI_MCA_orte_rsh_agent=/bin/false

override_dh_clean:
	dh_clean
	rm -rf src64 src64m

override_dh_auto_clean:
	echo "Running clean"
	rm -rf $(CURDIR)/debian/tmp
	rm -f src/configure.in
	rm -f src/config.log
	rm -f src/config/config.guess
	rm -f src/config/config.sub
	cd src/test; \
	for TEST in TEST_*; do \
	  rm -f $${TEST}.stdout $${TEST}.stderr; \
	done
	-dh_auto_clean

override_dh_autoreconf:
	cp /usr/share/misc/config.* src/config/
	cd src && ./config/update.sh
	rm -rf src64 && cp -a src src64
	rm -rf src64m && cp -a src src64m
	rm -rf src-static && cp -a src src-static
	rm -rf src64-static && cp -a src src64-static
	rm -rf src64m-static && cp -a src src64m-static


override_dh_auto_configure:
	dh_auto_configure -- --enable-shared $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp/usr
	dh_auto_configure -Dsrc-static -- $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp-static/usr
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_configure -Dsrc64 -- --enable-bigint --with-libname-ext=64 \
	  --enable-shared $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas64)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack64)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp64/usr
	dh_auto_configure -Dsrc64m -- --enable-mixedint --with-libname-ext=64m \
	  --enable-shared $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas64)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack64)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp64m/usr
	dh_auto_configure -Dsrc64-static -- --enable-bigint --with-libname-ext=64 \
	  $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas64)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack64)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp64-static/usr
	dh_auto_configure -Dsrc64m-static -- --enable-mixedint --with-libname-ext=64m \
	  $(extra_flags_common) \
	  --with-blas=yes --with-blas-lib="$(shell pkg-config --libs blas64)" \
	  --with-lapack=yes \
	    --with-lapack-lib="$(shell pkg-config --libs lapack64)" \
	    --with-fmangle-lapack="one-underscore"   \
	  --prefix=$(CURDIR)/debian/tmp64m-static/usr
	#dh_auto_configure -p libhypre-complex -- $(extra_flags) --enable-shared --enable-complex
endif

override_dh_auto_build:
	dh_auto_build -Dsrc
	dh_auto_build -Dsrc-static
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_build -Dsrc64
	dh_auto_build -Dsrc64m
	dh_auto_build -Dsrc64-static
	dh_auto_build -Dsrc64m-static
endif

override_dh_auto_install:
	dh_auto_install -Dsrc
	dh_auto_install -Dsrc-static
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_install -Dsrc64
	dh_auto_install -Dsrc64m
	dh_auto_install -Dsrc64-static
	dh_auto_install -Dsrc64m-static
endif

# disable build tests for these arches:
# ia64 consistently times out on tests
# armel occasionally times out
ARCH_NO_TEST_LIST = armel ia64

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_TEST_LIST)$(space)))
  RUNTEST=no
endif
# don't run tests if the nocheck build option has been specified
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

# do not run these tests at build time:
#   TEST_bench, takes an unacceptably long time to run (more than all other tests combined)
#   TEST_examples, TEST_fei, executables are not available
#   TEST_timing, the unusual shell arithmetic in efficiency.sh is not supported
SKIP_TEST_LIST = TEST_bench TEST_examples TEST_fei TEST_timing

ifeq (64,$(DEB_HOST_ARCH_BITS))
TEST_SRC_DIRS = src src-static src64 src64-static
else
TEST_SRC_DIRS = src src-static
endif

override_dh_auto_test:
	set -e; \
	if [ "$(RUNTEST)" = "no" ]; then \
	  echo Tests have been disabled on $(DEB_HOST_ARCH); \
	else echo "Building tests"; \
	  for build in $(TEST_SRC_DIRS); do \
